import {BaseResourceType} from "../../models";
import {Relation3TiersNameSpace} from "./relation-3-tiers-namespace.model";
import {Relation3TiersAction} from "./relation-3-tiers.action";

export class Relation3TiersActionHelper {
  static getAll(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.GetAll>): Relation3TiersAction.GetAll {
    return new relation3TiersNameSpace.GetAll(...args);
  }

  static getAllSuccess<TResource extends BaseResourceType>(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.GetAllSuccess>): Relation3TiersAction.GetAllSuccess<TResource> {
    return new relation3TiersNameSpace.GetAllSuccess(...args);
  }

  static getAllFail(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.GetAllFail>): Relation3TiersAction.GetAllFail {
    return new relation3TiersNameSpace.GetAllFail(...args);
  }

  static getById(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.GetById>): Relation3TiersAction.GetById {
    return new relation3TiersNameSpace.GetById(...args);
  }

  static getByIdSuccess<TResource extends BaseResourceType>(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.GetByIdSuccess>): Relation3TiersAction.GetByIdSuccess<TResource> {
    return new relation3TiersNameSpace.GetByIdSuccess(...args);
  }

  static getByIdFail(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.GetByIdFail>): Relation3TiersAction.GetByIdFail {
    return new relation3TiersNameSpace.GetByIdFail(...args);
  }

  static create(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.Create>): Relation3TiersAction.Create {
    return new relation3TiersNameSpace.Create(...args);
  }

  static createSuccess(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.CreateSuccess>): Relation3TiersAction.CreateSuccess {
    return new relation3TiersNameSpace.CreateSuccess(...args);
  }

  static createFail(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.CreateFail>): Relation3TiersAction.CreateFail {
    return new relation3TiersNameSpace.CreateFail(...args);
  }

  static createResource(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.CreateResource>): Relation3TiersAction.CreateResource {
    return new relation3TiersNameSpace.CreateResource(...args);
  }

  static createResourceSuccess(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.CreateResourceSuccess>): Relation3TiersAction.CreateResourceSuccess {
    return new relation3TiersNameSpace.CreateResourceSuccess(...args);
  }

  static createResourceFail(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.CreateResourceFail>): Relation3TiersAction.CreateResourceFail {
    return new relation3TiersNameSpace.CreateResourceFail(...args);
  }

  static delete(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.Delete>): Relation3TiersAction.Delete {
    return new relation3TiersNameSpace.Delete(...args);
  }

  static deleteSuccess(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.DeleteSuccess>): Relation3TiersAction.DeleteSuccess {
    return new relation3TiersNameSpace.DeleteSuccess(...args);
  }

  static deleteFail(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.DeleteFail>): Relation3TiersAction.DeleteFail {
    return new relation3TiersNameSpace.DeleteFail(...args);
  }

  static update(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.Update>): Relation3TiersAction.Update {
    return new relation3TiersNameSpace.Update(...args);
  }

  static updateSuccess(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.UpdateSuccess>): Relation3TiersAction.UpdateSuccess {
    return new relation3TiersNameSpace.UpdateSuccess(...args);
  }

  static updateFail(relation3TiersNameSpace: Relation3TiersNameSpace, ...args: ConstructorParameters<typeof Relation3TiersAction.UpdateFail>): Relation3TiersAction.UpdateFail {
    return new relation3TiersNameSpace.UpdateFail(...args);
  }
}
